﻿using IRaCIS.Core.Domain.Share;
using IRaCIS.Core.Domain.Share.Reading;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IRaCIS.Core.Domain.Models
{
    public class ReadingClinicalDataView : Entity
    {
       
        /// <summary>
        /// 项目ID
        /// </summary>
        public Guid TrialId { get; set; }

        /// <summary>
        /// 受试者ID
        /// </summary>
        public Guid SubjectId { get; set; }


        /// <summary>
        /// 阅片
        /// </summary>
        public Guid? ReadingId { get; set; }


        /// <summary>
        /// 项目配置临床类型ID
        /// </summary>
        public Guid ClinicalDataTrialSetId { get; set; }

        /// <summary>
        /// 项目配置临床类型Name
        /// </summary>
        public string ClinicalDataSetName { get; set; }


        public ClinicalUploadType ClinicalUploadType { get; set; }


        /// <summary>
        /// 
        /// </summary>
        public ClinicalLevel ClinicalDataLevel { get; set; }

        /// <summary>
        /// 是否为CRC上传
        /// </summary>
        public bool IsCRCUpload { get; set; }

        /// <summary>
        /// 是否签名
        /// </summary>
        public bool IsSign { get; set; }

    }
}
